<?php

if(ini_get('zlib.output_compression')) {
  ini_set('zlib.output_compression', 'Off');
}

$base_url = "https://www.proscia.it/pbrowse/";    // URL base per wrapping link

if (isset($_GET['browse'])) {

  if (!preg_match("#^http(s)?://[^\\s]+#", $_GET['browse'])) { 
    $browse = "http://www.google.com/search?q=" . $_GET['browse'];
  } else {
    $browse = $_GET['browse'];
    $parameters = "";

    $keys = array_keys($_GET);
    foreach($keys as $key) {
      if ($key === "browse") {
        continue;
      }
      if ($parameters === "") {
        $parameters = "?";
      } else {
        $parameters .= "&";
      }
      $parameters .= $key . "=" . $_GET[$key];
    }
  }

  set_time_limit(0);
  include('simple_html_dom.php');


  if (($fp = @fopen($browse . $parameters, "rb")) !== FALSE) {
    $meta = stream_get_meta_data($fp);
    $regexContentType = "#Content-Type:(\\s)?([a-z0-9/-]+).*#i";
    foreach ($meta['wrapper_data'] as $m) {
      if (preg_match($regexContentType, $m)) {
        $type = preg_replace($regexContentType, "$2", $m); 
      }
      if ($type !== NULL) {
        break;
      }
    }
    $content = "";
    $sent_header = false;
    while ($buf = @fread($fp, 8192)) {
      if ($type === "") {
        $finfo = new finfo(FILEINFO_MIME);
        $type = $finfo->buffer($buf);
      }

      if (!$sent_header) {
        header("Content-type: ". $type);
        $sent_header = true;
      }

      if ($type !== "text/html") {
        echo $buf;
        ob_flush();
        flush();

        usleep(100);
      } else {
        $content .= $buf;
      }
    }

    if ($type === "text/html") {
      $html = str_get_html($content);

      $browse = preg_replace("#(http(s)?://[^\\s/]+(/)?).*#", "$1", $browse);
      $rewrite = array('src', 'href');

      foreach ($rewrite as $attr) {
        $n_elements = sizeof($html->find("*[$attr]"));
        for ($i = 0; $i < $n_elements; $i++) {
          $src = rawurldecode($html->find("*[$attr]", $i)->$attr);
          if ($src === "#" || preg_match("#^javascript:.*#i", $src)) {
            continue;
          }
          if (!preg_match("#^http(s)?://[^\\s]+#", $src)) {
            if ($browse[strlen($browse) - 1] !== "/") {
              $browse .= "/";
            }
            if ($src[0] === "/") {
              $src = substr($src, 1, strlen($src) - 1);
            }
            $src = $browse . $src;
          }

          $html->find("*[$attr]", $i)->$attr = $base_url . "?browse=" . rawurlencode($src);
        }
      }

      echo $html;
    }
  } else {
    echo  "Error: cannot read <a href=\"" . urlencode($browse) ."\">" . $browse . "</a>";  
  }
  exit;
} else if (sizeof($_GET) > 0) {
  die("Illegal argument!");
}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
<head>
  <title>pBrowse</title>

  <script language="javascript" type="text/javascript">
  <!--
  function showBar() {
    document.getElementById('addressbar').style.display = 'block';
  }

  function hideBar() {
    document.getElementById('addressbar').style.display = 'none';
  }
  //-->
  </script>

  <style type="text/css">
  html, body {
  color: #333;
  margin: 0px;
  padding: 0px;
  height: 100%;
  }

  #topline {
  display: block;
  height: 1px;
  width: 100%;
  }

  #addressbar {
  font-family: Sans-serif;
  font-size: 14px;
  background: #eee;
  padding: 4px 0px 4px 4px;
  display: block;
  border-bottom: solid 1px #666;
  text-align: center;
  }

  label {
  font-weight: bolder;
  }

  input[type=text] { 
  font-size: inherit;
  border-color: #666666 #CCCCCC #CCCCCC;
  border-style: solid;
  border-width: 1px;
  color: #666666;
  width: 50em;
  }


  #closebar {
  float: right;
  font-weight: bolder;
  margin-right: 1em;
  vertical-align: middle;
  }

  #closebar a {
  color: #333333;
  text-decoration: none;
  }

  iframe {
  display: block;
  width: 100%;
  border: none;
  }
  </style>
</head>
 
<body>
  <div id="topline" onmouseover="showBar();"></div>
  <div id="addressbar">
  <div id="closebar"><a href="#" onclick="hideBar();" title="Close Bar">X</a>
  </div>
    <form method="get" target="content" action="index.php">
      <label>Address:&nbsp;</label><input type="text" name="browse" id=
      "browse" value="http://" /> <input type="submit" value="Go" />
    </form>
  </div>
  <iframe src="about:blank" id="content" name="content"></iframe>
  <script language="javascript" type="text/javascript">
  <!--
  document.getElementById('browse').focus();

  var bar_height = document.getElementById('addressbar').clientHeight;
  var screen_height = window.innerHeight || document.body.clientHeight;

  document.getElementById('content').style.height = (screen_height - bar_height - 5) + 'px';
  //-->
  </script>
</body>
</html>
